library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity SPI2 is
    Port ( SPI_Data : in  STD_LOGIC;
           SPI_Enable : in  STD_LOGIC;
           SPI_Clock : in  STD_LOGIC;
		   Reseta : in std_logic;
		   Enable_out : out std_logic;
           Ausgang : out std_logic_vector(15 downto 0)
		   );
end SPI2;

architecture Behavioral of SPI2 is

signal SPI_SR : std_logic_vector(15 downto 0):="0000000000000000";
signal counter : integer range 0 to 16;
signal OK_Programm : std_logic;

begin

Enable_out <= '1';

SchiebeReg : process(SPI_Clock, SPI_Enable,Reseta,OK_Programm)
begin
   if (Reseta = '0') then
      SPI_SR(15 downto 0) <= (others => '0');
		counter <= 0;
   elsif (SPI_Enable = '0') then
      if rising_edge(SPI_Clock) then
	      SPI_SR <= SPI_SR(14 downto 0) & SPI_Data;
			counter <= counter + 1;
	   end if;
	end if;
	if (OK_Programm = '1') then
		counter <= 0;
		SPI_SR(15 downto 0) <= (others => '0');

	end if;
end process;

Ausgabe : process(SPI_Enable, OK_Programm)
begin
   if rising_edge(SPI_Enable) then
		if (counter = 16) then
		Ausgang <= SPI_SR;
		OK_Programm <= '1';
		else
		OK_Programm <= '1';
		end if;
	end if;
	if (OK_Programm = '1') then
		OK_Programm <= '0';
	end if;
end process;


end Behavioral;

