library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity SPI2 is
    Port ( SPI_Data : in  STD_LOGIC;
           SPI_Enable : in  STD_LOGIC;
           SPI_Clock : in  STD_LOGIC;
		   Reseta : in std_logic;
		   Enable_out : out std_logic;
           Ausgang : out std_logic_vector(15 downto 0)
		   );
end SPI2;

architecture Behavioral of SPI2 is

signal SPI_SR : std_logic_vector(15 downto 0):="0000000000000000";
signal counter : integer range 0 to 16;

begin

Enable_out <= '1';

SchiebeReg : process(SPI_Clock, SPI_Enable,Reseta) --OK_Programm in sens liste
begin
   if (Reseta = '0') then
      SPI_SR(15 downto 0) <= (others => '0');
		counter <= 0;
   elsif (SPI_Enable = '0') then
      if rising_edge(SPI_Clock) then
		if counter = 16 then
		counter <= 1;
		else
		counter <= counter + 1;
		end if;
	    SPI_SR <= SPI_SR(14 downto 0) & SPI_Data;
	  end if;
	end if;
	
end process;

Ausgabe : process(SPI_Enable) --OK_Programm in sens liste
begin
   if rising_edge(SPI_Enable) then
		if (counter = 16) then
			Ausgang <= SPI_SR;
		end if;
	end if;
end process;


end Behavioral;

