library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity SPI2 is
    Port ( SPI_Data : in  STD_LOGIC;
           SPI_Enable : in  STD_LOGIC;
           SPI_Clock : in  STD_LOGIC;
		   Takteingang : in std_logic;
		   Enable_out : out std_logic;
           Ausgang : out std_logic_vector(15 downto 0)
		   );
end SPI2;

architecture Behavioral of SPI2 is

signal SPI_SR : std_logic_vector(15 downto 0):="0000000000000000";
signal counter : integer range 0 to 16;

signal SPI_Enable_old : std_logic;
signal SPI_Clock_old : std_logic;

begin

Enable_out <= '1';

SchiebeReg : process(Takteingang)
begin
	if rising_edge(Takteingang) then
	-- SPI_Data_old <= SPI_Data;
	SPI_Enable_old <= SPI_Enable;
	SPI_Clock_old <= SPI_Clock;
		
		if (SPI_Enable = '0') then
			if SPI_Clock_old = '0' and SPI_Clock = '1' then
			SPI_SR <= SPI_SR(14 downto 0) & SPI_Data;
			counter <= counter + 1;
			end if;
		else
		counter <= 0;
		SPI_SR(15 downto 0) <= (others => '0');
		end if;
	
		if SPI_Enable_old = '0' and SPI_Enable = '1' then
			if (counter = 16) then
			Ausgang <= SPI_SR;
			end if;
		end if;

	end if;
end process;

end Behavioral;

